-- Ksztette : Molnr Sndor 2008.10.07
-- egy dekdos hexa kijelz 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity dekad_kij is
    Port (d    : in std_logic_vector(3 downto 0) ;-- megjelentend szam: 0..F
         digit : out std_logic_vector(3 downto 0); -- digit engedlyezs aktv '0'
	      seg : out std_logic_vector(7 downto 0); -- szegmens meghajts aktv '0'
			tobbi_led:out std_logic_vector(7 downto 0)
		);
end dekad_kij;
architecture Behavioral of dekad_kij is
begin
  tobbi_led<=(others=>'0');  --Ez kikapcsolja a nem hasznlatos ledeket
  digit	 <= "1110";-- csak a jobb szls kijelzt engedlyezem a 4 kzl
          --     D
	     --ABCDEFGP
  seg <= "00000011" when d = "0000" else  --0
         "10011111" when d = "0001" else  --1
         "00100101" when d = "0010" else  --2
         "00001101" when d = "0011" else  --3
         "10011001" when d = "0100" else  --4
         "01001001" when d = "0101" else  --5
         "01000001" when d = "0110" else  --6
         "00011111" when d = "0111" else  --7
         "00000001" when d = "1000" else  --8
         "00011001" when d = "1001" else  --9
			"00010001" when d = "1010" else  --A
	      "11000001" when d = "1011" else  --B   
         "01100011" when d = "1100" else  --C  
         "10000101" when d = "1101" else  --D	
         "01100001" when d = "1110" else  --E  
         "01110001"  ;						   --F
end Behavioral;
