-- Ksztette : Molnr Sndor 2008.10.07
--2 dekdos hexa kijelz

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dekad_kij is
    Port (
			clk50 : in std_logic;
			rst : in std_logic;
			tobbi_led : out std_logic_vector(7 downto 0);
			d1    : in std_logic_vector(3 downto 0) ;-- megjelentend szam1: 0..F
			d2    : in std_logic_vector(3 downto 0) ;-- megjelentend szam2: 0..F
         digit : out std_logic_vector(3 downto 0); -- digit engedlyezs aktv '0'
	      seg : out std_logic_vector(7 downto 0) -- szegmens meghajts aktv '0'
		);
end dekad_kij;

architecture Behavioral of dekad_kij is
signal hertz_count : std_logic_vector(31 downto 0);
signal masodperc : std_logic :='0';
signal s : std_logic :='0';
signal akt : STD_LOGIC_VECTOR (3 downto 0);

begin

tobbi_led <=(others =>'0');

process (clk50,rst)
begin
if rst='1' then
	hertz_count <=(others =>'0');
   masodperc <='0';
elsif clk50'event and clk50 ='1' then
   hertz_count <= hertz_count+1;
	--cd <= not cd;
	
	case s is
		when '0' => akt <= d1;   digit <= "111" & masodperc;
		when others => akt <= d2;     digit <= "11" & not masodperc & "1";
	end case;
	
	case akt is
		when 	"0000" => seg <= "00000011"  ;
		when  "0001" => seg <= "10011111"  ;
		when  "0010" => seg <= "00100101"  ;
		when  "0011" => seg <= "00001101"  ;
		when  "0100" => seg <= "10011001"  ;
		when  "0101" => seg <= "01001001"  ;
		when  "0110" => seg <= "01000001"  ;
		when  "0111" => seg <= "00011111"  ;
		when  "1000" => seg <= "00000001"  ;
		when  "1001" => seg <= "00011001"  ;
		when  "1010" => seg <= "00010001"  ;
		when  "1011" => seg <= "11000001"  ;
		when  "1100" => seg <= "01100011"  ;
		when  "1101" => seg <= "10000101"  ;
		when  "1110" => seg <= "01100001"  ;
		when  others => seg <= "01110001"  ;
	end case;


	--hertz_count <=hertz_count + 1 ;
	
	if hertz_count = 50000000-1 then
		hertz_count <= (others => '0');
		masodperc <= not masodperc;
		s <= not s;
	end if;
end if;
	
end process;			   

end Behavioral;
