-- nulla krbefuttats
-- "krbefut" a nulla szegmensein
-- errl a pldrl nekem halvnylila fingom sincs, mert 1. nem ezt kaptam, 2. ez konzultci vge fele volt mr, s mr 
-- gy nztem ki, mint a mosott szar.
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity nullas is
    Port ( clk50 : in  STD_LOGIC; --50Hz-es rajel
           rst : in  STD_LOGIC;   -- aszinkron reset
           seg : out STD_LOGIC_VECTOR (7 downto 0); --azrt 8, mert a tizedes pont is belekerl (7+1)
		   digit: out STD_LOGIC_VECTOR (1 downto 0); --2 bites
		   digit_kij: out STD_LOGIC -- nem emlkszek. hogy ez milyen volt 
		   
end nullas;

architecture Behavioral of villog1s is
 signal hertz_count: std_logic_vector(31 downto 0); --mhz oszt
 signal bcdint: std_logic_vector(3 downto 0); -- 4 bites 
 signal digitp: std_logic_vector(1 downto 0); -- 2 bites 
 
 -- a program kt processbl ll, ebbl az egyik a "krbefuts" a msik pedig a kijelzs
 
-- krbefut process
process (clk50,rst, hertz_count, bcdint)
begin
	if rst='1' then
		bcdint<=(others=>'0')
		hertz_count<=(others=>'0')
		digitp="10";
	
	elsif clk50'event and clk50='1' then
		hertz_count=hertz_count+1;
			if hertz_count=20e6-1 then     -- ha kisebbre vlasztjuk (pl. 4) akkor mr a 4. rajelnl trtnik vltozs (knnyebb szimullni)
				hertz_count<=(others=>'0');
				if bcdint="0101" then
					bcdint<="0000";
					digitp<=not digitp;
				else
					digitp<=digitp+1;
				end if;
			end if;
		
	end if;
	
end process;

--a kijelzs process
process (bcdint, digitp)
begin
	digit<=digitp;
	digit_kij: case bcdint is 
			when "0000" => seg <="11101111";
			when "0001" => seg <="111"; --rk tudja
			when "0010" => seg <= "";   -- ezt is 
			when "0100" => seg <="11110011";
			when others => seg <="11101111";
		end case;

end process;

 