----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:16:33 11/21/2010 
-- Design Name: 
-- Module Name:    cshazi - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity cshazi is
    Port ( res	: in STD_LOGIC;		-- reset
			  clk	: in STD_LOGIC;		-- orajel
			  btn	: in STD_LOGIC_VECTOR (1 downto 0);		-- a forgasiranyt allito nyomogombok. BTN0: jobbra, BTN1: balra. 
			  q 	: out STD_LOGIC_VECTOR (5 downto 0);	-- a kijelzo kulso szegmensei (a jobb felso a 0.) (active low)
			  qn	: out STD_LOGIC_VECTOR (1 downto 0);	-- a kijelzo nem hasznalt szegmensei (a kozepso es a tizedespont) (active low).
			  dig	: out STD_LOGIC_VECTOR (3 downto 0)		-- a 4 db 7-szegmenses szamjegy engedelyezese (active low)
			  );
end cshazi;

architecture Behavioral of cshazi is

signal qLocal : STD_LOGIC_VECTOR (5 downto 0);

begin
	
	dig <= "1110"; 	-- a jobb szelso szamjegy legyen aktiv
	qn <= "11"; 		-- nem hasznlt szegmensei ne vilagitsanak
	
	process (clk, res, btn, qLocal)
	begin
		if (res = '1') then qLocal <= "111100"; 
		else 	if (clk'event and clk = '1') then   
					if (btn(0) = '1') then qLocal <= qLocal(4 downto 0) & qLocal(5); 	-- gombnyomasra egy szegmenssel jobbra forgatas
					else 	if (btn(1) = '1') then qLocal <= qLocal(0) & qLocal(5 downto 1); 	-- gombnyomasra egy szegmenssel balra forgatas
							else qLocal <= qLocal;
							end if; 
					end if;
				end if;
		end if;
		q <= qLocal; 
	end process; 
	
end Behavioral;


