-- Ksztette : Vgh Tams 2006.11.15.
-- egy dekdos hexa kijelz 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity dekad_kij is
    Port (d    : in std_logic_vector(3 downto 0) ;-- megjelentend szam: 0..F
         digit : out std_logic_vector(3 downto 0); -- digit engedlyezs aktv '0'
	      seg : out std_logic_vector(7 downto 0) -- szegmens meghajts aktv '0'
		);
end dekad_kij;

architecture Behavioral of dekad_kij is

begin
  digit	 <= "1110";-- csak a jobb szls kijelzt engedlyezem a 4 kzl
  seg <= "00000011" when d = "0000" else
         "10011111" when d = "0001" else
         "00100101" when d = "0010" else
         "00001101" when d = "0011" else
         "10011001" when d = "0100" else
         "01001001" when d = "0101" else
         "01000001" when d = "0110" else
         "00011111" when d = "0111" else
         "00000001" when d = "1000" else
         "00011001" when d = "1001" else	
			"00010001" when d = "1010" else	
	      "11000001" when d = "1011" else   
         "01100011" when d = "1100" else  
         "10000101" when d = "1101" else	
         "01100001" when d = "1110" else  
         "01110001"  ;						   

end Behavioral;
