library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity led_dek is
    Port ( d : in std_logic_vector(3 downto 0);
           s : out std_logic_vector(6 downto 0);
	   digit0 : out std_logic );
end led_dek;

architecture Behavioral of led_dek is
begin
  digit0	 <= '0';
  s   <= "1000000" when d = "0000" else
         "1111001" when d = "0001" else
         "0100100" when d = "0010" else
         "0110000" when d = "0011" else
         "0011001" when d = "0100" else
         "0010010" when d = "0101" else
         "0000010" when d = "0110" else
         "1111000" when d = "0111" else
         "0000000" when d = "1000" else
         "0011000" when d = "1001" else
         "0001000" when d = "1010" else
	      "0000011" when d = "1011" else
         "1000110" when d = "1100" else
         "0100001" when d = "1101" else
         "0000110" when d = "1110" else
         "0001110"  ;	
end Behavioral;
