-- Ksztette : Vgh Tams 2006.11.15.

--20ms-os jelet elllt idzt ramkr
--a kimeneti jelzs (1 bites zenet) csak egy rajel ideig tart!!

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity oszto_20ms is
    Port ( clk50 : in std_logic;
           rst : in std_logic;
		 x20ms_out: out std_logic);
end oszto_20ms;

architecture Behavioral of oszto_20ms is
 signal x20ms_count	: std_logic_vector(31 downto 0) ;	-- prellmentest oszt

begin
process (clk50, rst)
begin
if rst = '1' then
     x20ms_count <= (others => '0') ;	
	  x20ms_out <= '0' ;	-- 

elsif clk50'event and clk50 = '1' then -- f rajel felfut le 
	x20ms_count <= x20ms_count + 1 ;	 --ketyeg az ra

	if x20ms_count = 1000000-1 then  -- 50 MHz-et kell leosztani  20 ms-ra
		x20ms_out <= '1' ;	--20ms-os kimenetet aktivlom (1 rajel ideig fog csak tartani!)
		x20ms_count <= (others => '0') ;
	else 
		x20ms_out <= '0' ; 
		  --csak 1 rajel ideig tarthat a kiadott parancs (ez most 1 bites parancs!)
	end if ;


end if ;
end process ;	

end Behavioral;
