library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity gombdetektor is
	port ( clk50     : in    std_logic; --50MHz-es f rajel
          rst       : in    std_logic; --aszinkron trls
          digit     : out   std_logic_vector (3 downto 0);--htszegmense kijelz digit eng. 
          led       : out   std_logic; --LED0
			 led2       : out   std_logic; --LED0
			 led3       : out   std_logic; --LED0
          seg       : out   std_logic_vector (6downto 0);--htszegmense kijelz segmens vezrls 
			 gomb		  : in 	 std_logic_vector (3 downto 0);
			 g:in std_logic);
			 
	  TYPE allapotok IS (megnyomasra_var,elengedesre_var);-- az FSM llapotai		 
			 
end gombdetektor;

architecture Behavioral of gombdetektor is
  -- signal d          : std_logic_vector (3 downto 0);--hexa szamll, htszegmenses kijelzs
   signal x2s_out  : std_logic;--20ms-os mintavteli id jelzse
	signal gomb_esemeny    : std_logic;-- gombnyoms esemny jelzse 
	signal x2s_count	: std_logic_vector(31 downto 0) ;	-- prellmentest oszt
	signal villagit: std_logic:='1';
	signal curr:std_logic_vector(1 downto 0);
begin
process(clk50,gomb)
begin
	if rst='1' then
	gomb_esemeny<='0';
	elsif clk50'event and clk50='1' then
		if x2s_out='0' then
			if villagit='1' then
				if gomb="0001" then 	gomb_esemeny<='1'; 	curr<="00";
				elsif gomb="0010" then 	gomb_esemeny<='1' ; curr<="01";
				elsif gomb="0100" then 	gomb_esemeny<='1';  curr<="10";
				elsif gomb="1000" then 	gomb_esemeny<='1' ; curr<="11";
				end if;
			end if;
		else
				gomb_esemeny<='0';
		end if;
	end if;
end process;
led<=gomb_esemeny;
led2<=x2s_out;
led3<=villagit;
----
--gomb_esemeny<=
--	'1' when x2s_out='0' and gomb="0001" else
--	'0' when x2s_out='1';
--	
--gomb_esemeny<=
--	'1' when g='1';
process(clk50,gomb_esemeny)
begin
	if rst='1' then
	villagit<='1';
	
	x2s_out<='0';
	x2s_count<=(others =>'0' );
	elsif clk50'event and clk50='1' then
		if gomb_esemeny ='1' then
			villagit<='0';
			x2s_count<=x2s_count+1;
			if x2s_count=50000000 then 
			x2s_out<='1'; 
			x2s_count<=(others => '0');
			end if;
			
		else
			villagit<='1';
--			x2s_count<=(others => '0');
			x2s_out<='0';
			
		end if;
	end if;
end process;
digit<="1110";
--x2s_out<=
--	'1' when gomb="0001" else
--	'0' when gomb="0010";
seg<=
	"1111001" when gomb_esemeny='1' and curr="00" else
	"0100100" when gomb_esemeny='1' and curr="01" else
	"0110000" when gomb_esemeny='1' and curr="10" else
	"0011001" when gomb_esemeny='1' and curr="11" else
	"1111111";	




end Behavioral;

